OpenPose 1.0.0rc2 OpenPose: A Real-Time Multi-Person Key-Point Detection And Multi-Threading C++ Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | List of all members
cl::Image3D Class Reference

Class interface for 3D Image Memory objects. More...

`#include <cl2.hpp>`

Inherits cl::Image.

## Public Member Functions
| Image3D (const Context &context, cl_mem_flags flags, ImageFormat format, size_type width, size_type height, size_type depth, size_type row_pitch=0, size_type slice_pitch=0, void *host_ptr=NULL, cl_int *err=NULL)
| Constructs a 3D Image in a specified context. More...
| Image3D ()
| Default constructor - initializes to NULL. More...
| Image3D (const cl_mem &image3D, bool retainObject=false)
| Constructor from cl_mem - takes ownership. More...
Image3D & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy. More...
| Image3D (const Image3D &img)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Image3D & | operator= (const Image3D &img)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Image3D (Image3D &&img) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Image3D & | operator= (Image3D &&img)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
Public Member Functions inherited from cl::Image
template<typename T >
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo(). More...
template<cl_int name>
detail::param_traits < detail::cl_image_info, name > ::param_type | getImageInfo (cl_int *err=NULL) const
| Wrapper for clGetImageInfo() that returns by value. More...
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to NULL. More...
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership. More...
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership. More...
| Memory (const Memory &mem)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Memory & | operator= (const Memory &mem)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Memory (Memory &&mem) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Memory & | operator= (Memory &&mem)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
template<typename T >
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo(). More...
template<cl_int name>
detail::param_traits < detail::cl_mem_info, name > ::param_type | getInfo (cl_int *err=NULL) const
| Wrapper for clGetMemObjectInfo() that returns by value. More...
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=NULL)
| Registers a callback function to be called when the memory object is no longer needed. More...
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
| Wrapper ()
| Wrapper (const cl_type &obj, bool retainObject)
| Wrapper (const Wrapper< cl_type > &rhs)
| Wrapper (Wrapper< cl_type > &&rhs) CL_HPP_NOEXCEPT_
| ~Wrapper ()
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
Wrapper< cl_type > & | operator= (Wrapper< cl_type > &&rhs)
Wrapper< cl_type > & | operator= (const cl_type &rhs)
const cl_type & | operator() () const
cl_type & | operator() ()
const cl_type | get () const
cl_type | get ()

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Member Functions inherited from cl::Image
| Image ()
| Default constructor - initializes to NULL. More...
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership. More...
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy. More...
| Image (const Image &img)
| Copy constructor to forward copy to the superclass correctly. Required for MSVC. More...
Image & | operator= (const Image &img)
| Copy assignment to forward copy to the superclass correctly. Required for MSVC. More...
| Image (Image &&img) CL_HPP_NOEXCEPT_
| Move constructor to forward move to the superclass correctly. Required for MSVC. More...
Image & | operator= (Image &&img)
| Move assignment to forward move to the superclass correctly. Required for MSVC. More...
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

Class interface for 3D Image Memory objects.

See Memory for details about copy semantics, etc.

See Also
  Memory

## Constructor & Destructor Documentation

cl::Image3D::Image3D | ( | const Context & | context,
|  | cl_mem_flags | flags,
|  | ImageFormat | format,
|  | size_type | width,
|  | size_type | height,
|  | size_type | depth,
|  | size_type | row_pitch = `0`,
|  | size_type | slice_pitch = `0`,
|  | void * | host_ptr = `NULL`,
|  | cl_int * | err = `NULL`
| ) |  |
| inline

Constructs a 3D Image in a specified context.

Wraps clCreateImage().

cl::Image3D::Image3D | ( |  | ) |
| inline

Default constructor - initializes to NULL.

cl::Image3D::Image3D | ( | const cl_mem & | image3D,
|  | bool | retainObject = `false`
| ) |  |
| inline explicit

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

cl::Image3D::Image3D | ( | const Image3D & | img | ) |
| inline

Copy constructor to forward copy to the superclass correctly. Required for MSVC.

cl::Image3D::Image3D | ( | Image3D && | img | ) |
| inline

Move constructor to forward move to the superclass correctly. Required for MSVC.

## Member Function Documentation

Image3D& cl::Image3D::operator= | ( | const cl_mem & | rhs | ) |
| inline

Assignment from cl_mem - performs shallow copy.

See Memory for further details.

Image3D& cl::Image3D::operator= | ( | const Image3D & | img | ) |
| inline

Copy assignment to forward copy to the superclass correctly. Required for MSVC.

Image3D& cl::Image3D::operator= | ( | Image3D && | img | ) |
| inline

Move assignment to forward move to the superclass correctly. Required for MSVC.

The documentation for this class was generated from the following file:

- /home/travis/build/CMU-Perceptual-Computing-Lab/openpose/include/openpose/gpu/cl2.hpp